/*===================================
		Copyright Yakibomb
*///=================================

function VSCONDS_CLEANUP()
{
	foreach ( key, value in ROOT )
	{
		if ( typeof(value) == "array" && startswith(key, "VSCOND_ATTACHMENT_") ) {
			foreach ( parent, attachment in value ) {
				if ( attachment && attachment.IsValid() ) attachment.Kill();
			}
			delete ROOT[key];
		}
	}
	foreach ( key, value in ROOT )
	{
		if ( typeof(value) == "table" && startswith(key, "VSCOND_TABLE_") ) {
			local ent_index = split(key,"_");
			ent_index = ent_index[2].tointeger();
			VSCONDS_RemoveThinkToCondALL(ent_index);
			
			local ent_data = ROOT[key];
			local ent = ent_data[VSCond_MAX_Conditions];
			local ent_validate = ent_data[VSCond_MAX_Conditions + 1];
			
			if ( ent == ent_validate 
			  && ent.IsValid() )
			{
				foreach (condition,duration in ent_data ) {
					if ( condition >= VSCond_MAX_Conditions ) continue
					ent.RemoveVSCond(condition);
					//VSCOND_ENTS_UNDER_CONDS.remove(VSCOND_ENTS_UNDER_CONDS.find(ent_data));
				}
			}
			delete ROOT[key];
		}
	}
		
	local addvsconds = Entities.FindByName(null, "vscript_addvscond");

	if ( addvsconds ) addvsconds.Kill();
}