/*===================================
		Copyright Yakibomb
*///=================================


if (!("ConstantNamingConvention" in ROOT))
{
	ROOT["ConstantNamingConvention"] <- true;
	foreach (a,b in Constants)
		foreach (k,v in b)
			if (v == null)
				ROOT[k] <- 0;
			else
				ROOT[k] <- v;
}

if (!("GetPropInt" in ROOT))
{
	foreach (k, v in NetProps.getclass())
		if (k != "IsValid")
			getroottable()[k] <- NetProps[k].bindenv(NetProps);
}
/*===================================
		Function Checks
*///=================================

function VSCONDS_IsCondNumValid(condition, entity) {
	if ( !entity.IsEntValidAndAlive() ) return false;
	if ( type(condition) != "integer" ) return false;
}
function VSCONDS_ClampCondValue(condition) {
	local max = VSCOND_COND_NAMES.len() - 1;
	max = max < 0 ? 0 : max;
	local min = 0;
	return condition <= min ? min : condition > max ? max : condition;
}

function CBaseEntity_IsEntValidAndAlive() {
	local ent_valid = this;
	
	if ( GetPropInt(ent_valid, "m_lifeState") ) //checks if entity is not alive
		return false;
	
	if ( ent_valid.GetClassname() == "player" ) {
		local time = Time();
		if ( ent_valid.GetNextChangeClassTime() >= time 	//checks if player changed classes recently
		  || ent_valid.GetNextChangeTeamTime() >= time 		//checks if player changed teams recently
		  || ent_valid.GetNextRegenTime() >= time )			//checks if player touched resupply recently
		{
			//EntFireByHandle(ent_valid, "DispatchEffect", "ParticleEffectStop", 0.0, worldspawn, worldspawn);  
			return false;
		}
	}
	
	if ( ent_valid && ent_valid.IsValid() ) return true;
	
	return false
}

/*===================================
		Initializer
*///=================================

function VSCONDS_CondEntInit (ent) {
	local ent_cond_table = format("%s_%d", "VSCOND_TABLE", ent.entindex());
	if ( !( VSCOND_ENTS_UNDER_CONDS.find(ent_cond_table) ) ) {
		ROOT[ent_cond_table] <-  { };
		ROOT[ent_cond_table][VSCond_MAX_Conditions] <- ent;
		ROOT[ent_cond_table][VSCond_MAX_Conditions + 1] <- ent;
	}
		
	local finder = VSCOND_ENTS_UNDER_CONDS.find(ent_cond_table);
	if ( !finder ) ::VSCOND_ENTS_UNDER_CONDS.append(ent_cond_table);
}

function VSCONDS_GetCondFunc (condition) {
	if ( type(condition) != "integer" || condition < 0 ) condition = 0;
	
	local condition_name = format("%s%s", "FUNC_", VSCOND_COND_NAMES[condition]);
	local funcsh = ROOT[condition_name];
//	foreach( k, v in funcsh ) ClientPrint(null, 3, k + " " + v);
	return funcsh;
}


function VSCONDS_RemoveThinkToCond(ent,condition) {
//	if ( type(condition) != "integer" ) return;
//	ent = type(ent) == "integer" ? ent : ent.entindex();
	
	local Name = format("VSConds_%d_%d_*",ent,condition);
	DoEntFire(Name.tostring(), "Trigger", "", 0.0, worldspawn, worldspawn);
}
function VSCONDS_RemoveThinkToCondALL(ent) {
	ent = type(ent) == "integer" ? ent : ent.entindex();
	if (ent==0) return;
	local Name = format("VSConds_%d_*",ent);
	DoEntFire(Name.tostring(), "Trigger", "", 0.0, worldspawn, worldspawn);
}

/*=======================================
	Attachments, aka things parented to the entity with condition. Usually for particles, but can be anything
*///=====================================
function VSCONDS_AddAttachmentsEnt(ent,condition,attachment) {
	local array_name = format("%s_%d_%d", "VSCOND_ATTACHMENT", ent, condition)
	if ( !( array_name in ROOT ) ) ROOT[array_name] <- [];
	ROOT[array_name].append(attachment);
}
function VSCONDS_RemoveAttachmentEnt(ent,condition) {
	local array_name = format("%s_%d_%d", "VSCOND_ATTACHMENT", ent, condition)
	if ( !( array_name in ROOT ) ) { ROOT[array_name] <- []; return; }
	
	local array = ROOT[array_name];
	foreach ( key, attachment in array ) {
		if ( attachment && attachment.IsValid() ) attachment.Kill();
	}
	delete ROOT[array_name];
}
	
//=======================================

::VSCondFunctions <-
{
	
/*=======================================
	Particle stuff
*///=====================================

//	Quirk with this one: This stops any parented particles, but it stops all, not just one.
	function StopParticle(player) {
		EntFireByHandle(player, "DispatchEffect", "ParticleEffectStop", 0.0, player, player)
		
		if ( player in InvisibleAttribute ) {
			delete InvisibleAttribute[player];
		}
	}
	
	
/*=======================================
	Creates a team-specific particle, then parents it to an entity.
	The team that the provider (provider) is on is what the function selects as the particle.
	It is then parented to the entity (ent) based on an vector you set it to.
	
	Can optionally set RED (team2), BLU (team3), or NEUTRAL (team5), in that order.
	Defaults to RED if no other particles set.
*///=====================================

	function CreateTeamParticle(condition=null, provider=null, ent=null, particle_origin=null, team2="ping_circle", team3=null, team5=null) {
		if ( ent ) {
			local noparent = false
			local particle = null
			if ( team2 && !team3 && !team5 ) {
				particle = team2
			}
			else if ( team2 && team3 && !team5 ) {
				particle = ent.GetTeam() > 2 ? team3 : team2
			}
			else if ( team2 && team3 && team5 ) {
				if ( provider == null ) {
					particle = team5
				}
				else if ( provider.GetTeam() != 2 && provider.GetTeam() != 3 ) {
					particle = team5
				}
				else { particle = provider.GetTeam() > 2 ? team3 : team2 }
			}
			else if ( !team2 || !team3 || !team5 ) {
				if ( team2 ) {
					particle = team2
				}
				else if ( team3 ) {
					particle = team3
				}
				else {
					particle = team5
				}
			}
			
			if ( !particle_origin ) {
				particle_origin = ent.GetOrigin()
				noparent = true
			}
			
			particle = SpawnEntityFromTable("info_particle_system", 
			{
			//	targetname		= UniqueString(),
				effect_name		= particle,
				start_active	= 1,
				flag_as_weather	= 0,
				origin			= particle_origin,
			})
			if ( !noparent ) {
				DoEntFire("!self", "SetParent", "!activator", 0, ent, particle)
			}
			
			VSCONDS_AddAttachmentsEnt(ent.entindex(),condition,particle);
			return particle;
		}
		return null
	}
	
	
/*=======================================
	Creates a team-specific drip particle, then parents it to an entity.
	Same as above, but utilizes trigger_particle to create the "drip" effects. (like Jarate, afterburn, etc)
*///=====================================
	function CreateTeamParticleDrip(condition=null,provider=null, ent=null, particle_origin=Vector(0,0,0), team2="ping_circle", team3=null, team5=null) {
		if ( !ent ) return null;
		
		local particle = null
		if ( team2 && !team3 && !team5 ) {
			particle = team2
		}
		else if ( team2 && team3 && !team5 ) {
			particle = ent.GetTeam() > 2 ? team3 : team2
		}
		else if ( team2 && team3 && team5 ) {
			if ( provider == null ) {
				particle = team5
			}
			else if ( provider.GetTeam() != 2 && provider.GetTeam() != 3 ) {
				particle = team5
			}
			else { particle = provider.GetTeam() > 2 ? team3 : team2 }
		}
		else if ( !team2 || !team3 || !team5 ) {
			if ( team2 ) {
				particle = team2
			}
			else if ( team3 ) {
				particle = team3
			}
			else {
				particle = team5
			}
		}
		
		particle = SpawnEntityFromTable("trigger_particle", 
		{
	//		targetname		= UniqueString(),
			particle_name	= particle,
			spawnflags		= 65,	//1 + 64
			attachment_type	= 1,
			origin			= Vector(0,0,0),
			mins		= Vector(0,0,0),
			maxs		= Vector(0,0,0),
		});
		EntFireByHandle(particle, "StartTouch", null, 0, ent, ent);
		EntFireByHandle(particle, "Kill", null, 0.01, ent, ent);
		
		return particle;
	}


/*=======================================
	Creates a team-specific Beam particle, then parents it to an entity.
	Beam is aligned with entity's center. The particle_origin is where the beam originates from.
*///=====================================
	function CreateBeamParticle(condition=null, provider=null, ent=null, particle_origin=null, team2="ping_circle", team3=null, team5=null) {
		if ( !ent ) return null;
		
		local noparent = false
		local particle = null
		if ( team2 && !team3 && !team5 ) {
			particle = team2
		}
		else if ( team2 && team3 && !team5 ) {
			particle = ent.GetTeam() > 2 ? team3 : team2
		}
		else if ( team2 && team3 && team5 ) {
			if ( provider == null ) {
				particle = team5
			}
			else if ( provider.GetTeam() != 2 && provider.GetTeam() != 3 ) {
				particle = team5
			}
			else { particle = provider.GetTeam() > 2 ? team3 : team2 }
		}
		else if ( !team2 || !team3 || !team5 ) {
			if ( team2 ) {
				particle = team2
			}
			else if ( team3 ) {
				particle = team3
			}
			else {
				particle = team5
			}
		}
		
		if ( !particle_origin ) {
			particle_origin = ent.GetOrigin()
			noparent = true
		}
		
		local center;
		if ( !( ent in InvisibleAttribute ) ) {
			::InvisibleAttribute[ent] <- {};
			center = ent.CreateInvisibleWearable();
			::InvisibleAttribute[ent] <- center;
		}
		center = InvisibleAttribute[ent]
		
		particle = SpawnEntityFromTable("info_particle_system", 
		{
	//		targetname		= UniqueString(),
			effect_name		= particle,
			start_active	= 1,
			flag_as_weather	= 0,
			origin			= particle_origin,
			cpoint1			= center.GetName()
		});
		DoEntFire("!self", "SetParent", "!activator", 0, provider, particle);
		NetProps.SetPropEntity(particle,"m_hControlPointEnts",center);
		
		VSCONDS_AddAttachmentsEnt(ent.entindex(),condition,particle);
		
		return particle;
	}	



/*=======================================
// Utility
*///=====================================

/*=======================================
	Collect all child entities on parent entity, puts it into an array.
	Option to collect parent as well.
*///=====================================
	function CollectChildOnParent(entity, alsoparent=false) {
		local child_list = [];
		if (alsoparent) child_list = [entity];
		
		for ( local item = entity.FirstMoveChild(); item != null ; item = item.NextMovePeer() )
		{
			child_list.append(item)
		}
		return child_list;
	}
	
/*=======================================
	Colors entity, including all child entities
*///=====================================
	function Color(ent, r,g,b) {
		local child_list = VSCondFunctions.CollectChildOnParent(ent, true);
		
		foreach ( child in child_list ) {
			child.KeyValueFromString("rendercolor", format("%d %d %d", r, g, b) )
		}
	}
	
/*=======================================
	Colors weapons only; might be unfinished
*///=====================================
	function ColorWeapons(ent, r,g,b) {
		local wep = null
		while (wep = Entities.FindByClassname(wep, "tf_weapon*"))
		{
			if (wep.GetOwner() == ent)
			{
				wep.SetCustomViewModelModelIndex(GetModelIndex(wep.GetModelName()))
				wep.KeyValueFromString("rendercolor", format("%d %d %d", r, g, b) )
				printl(wep)
			}
		}
		wep = null
		while (wep = Entities.FindByClassname(wep, "tf_viewmodel"))
		{
			if (wep.GetOwner() == ent)
			{
				wep.KeyValueFromString("rendercolor", format("%d %d %d", r, g, b) )
				printl(wep)
			}
		}
		local main_viewmodel = NetProps.GetPropEntity(ent, "m_hViewModel")
		main_viewmodel.KeyValueFromString("rendermode", "2" )
		main_viewmodel.KeyValueFromString("rendercolor", format("%d %d %d", r, g, b) )
	}
	
	
/*=======================================
	Set Parent attachment
*///=====================================
	function SetParentAttachment(attachment,child,parent)
	{
		EntFireByHandle(child,"SetParent","!activator",0.0,parent,null);
		EntFireByHandle(child,"SetParentAttachment",attachment.tostring(),0.01,null,null);
	}
	
}


/*=======================================
	Create Invisible Wearable
	Used mainly for CreateBeamParticle(). May be unfinished.
*///=====================================

function CBaseEntity_CreateInvisibleWearable()
{
	PrecacheModel("models/empty.mdl")
	local wearable_model = GetModelIndex("models/empty.mdl")
	
	local wearable = Entities.CreateByClassname("tf_wearable")
	
	wearable.SetAbsOrigin(this.GetCenter())
	wearable.SetAbsAngles(this.GetLocalAngles())
	NetProps.SetPropInt(wearable, "m_bClientSideAnimation", 1)
	NetProps.SetPropInt(wearable, "m_bValidatedAttachedEntity", 1)
	NetProps.SetPropInt(wearable, "m_iTeamNum", this.GetTeam())
	NetProps.SetPropInt(wearable, "m_Collision.m_usSolidFlags", Constants.FSolid.FSOLID_NOT_SOLID)
	NetProps.SetPropInt(wearable, "m_CollisionGroup", 11)
	NetProps.SetPropInt(wearable, "m_fEffects", 129)
	
	NetProps.SetPropInt(wearable, "m_nModelIndex", wearable_model)
	NetProps.SetPropInt(wearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 65535)
	
	NetProps.SetPropInt(wearable, "m_AttributeManager.m_Item.m_iEntityLevel", 1)
	NetProps.SetPropInt(wearable, "m_AttributeManager.m_Item.m_bInitialized", 0)
	
	NetProps.SetPropEntity(wearable, "m_hOwnerEntity", this)
	wearable.SetOwner(this)

	Entities.DispatchSpawn(wearable)
	DoEntFire("!self", "SetParent", "!activator", 0, this, wearable)
	wearable.KeyValueFromString("targetname", "tf_wearable_vscript"+UniqueString())

	return wearable
}


/*=======================================
	Unfinished stuff ahead!
*///=====================================


/*

function CTFPlayer_AddInvisibleAttribute(attr="",val=1.0,dur=-1) {
	if ( this.GetClassname() != "player" ) { return }
	
	if ( !( this in InvisibleAttribute ) ) {
		::InvisibleAttribute[this] <- {}
		local wearable = this.CreateInvisibleWearable()
		::InvisibleAttribute[this] <- wearable
	}
	local wearable = InvisibleAttribute[this]
	
	local scope = null
	if( this.ValidateScriptScope() )
	{
		scope = this.GetScriptScope()
		
		if ( !("Weapon_Attr" in scope ) ) scope.Weapon_Attr <- []
		scope.Weapon_Attr.append(attr)
		
		if ( !("Weapon_Val" in scope ) ) scope.Weapon_Val <- []
		scope.Weapon_Val.append(val)
	}
	
	foreach (i, v in scope.Weapon_Name)
	{
		wearable.AddAttribute(scope.Weapon_Attr[i],scope.Weapon_Val[i],-1)
		printl(i + ": " + v)
	}
	//wearable.AddAttribute(attr,val,dur)
	wearable.ReapplyProvision()
}

function CBaseEntity_RemoveInvisibleAttribute(attr="") {
	if ( !( this in InvisibleAttribute ) ) {
		return
	}
	local wearable = InvisibleAttribute[this]
	wearable.RemoveAttribute(attr)
}


::debug_vscond <- function(cond=1,duration=-1)
{
	for (local i = 1; i <= MaxClients() ; i++)
	{
		local ent_valid = EntIndexToHScript(i)
		if (ent_valid == null) continue
			if ( !NetProps.GetPropInt(ent_valid, "m_lifeState") ) {
				ClientPrint(null,3,format("%s has VSCond %d for %d second(s)",ent_valid.tostring(),cond,duration))
				ent_valid.AddVSCond(cond,duration,worldspawn)
			}
	}
}
*/