/*===================================
		Copyright Yakibomb
*///=================================

/*
	Description
	- Entity has a skull'n'crossbones float above their head.
	- Works on all entities.
*/

class VS_COND_MARKED extends VSConds_Base
{
	function AddCond(entity,provider) { 
		local particle = VSCondFunctions.CreateTeamParticle(condition,provider, entity, null, "mark_for_death")
		
	//Writes particle to think entity's scope
		think_ent_scope.particle <- particle;
	}
	
	function Think() {
	//Reads particle from think ent's scope
		local particle = think_ent_scope.particle;
	//Validates, then positions immediately every frame
	//If entity or particle is invalid or doesn't exist, try to delete particle entity.
		if ( entity && entity.IsValid() && particle && particle.IsValid() )
			particle.KeyValueFromVector("origin",entity.EyePosition() + entity.EyeAngles().Up() * 16);
		else particle.Kill(); 

		return 0.0
	}
	
	function RemoveCond(entity,provider) {	}
}